#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pb emplace_back
#define m_p make_pair

const int INF = 1e18;
const long double eps = 1e-6;
struct Pnt {
    long double x,y;
    Pnt () {}
    Pnt (long double x,long double y): x(x), y(y) {}
    bool operator < (Pnt a) const {
        if (x == a.x) {
            return y < a.y;
        }
        return x < a.x;
    }
};
struct Vec {
    long double x,y;
    Vec () {}
    Vec (long double x,long double y): x(x), y(y) {}
    Vec (Pnt x,Pnt y): x(y.x - x.x), y(y.y - x.y) {}
    Vec operator * (long double k) const {
        return Vec(x * k,y * k);
    }
    long double ln () {
        return sqrt(x * x + y * y);
    }
};
struct Line {
    long double a,b,c;
    Line (Pnt x,Pnt y) {
        a = x.x - y.x;
        b = y.y - x.y;
        swap(a,b);
        c = -(a * x.x + b * x.y);
    }
};
long double dist2 (Pnt a,Pnt b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

long double dist2 (Pnt a,Line l) {
    return (long double)(abs(a.x * l.a + a.y * l.b + l.c) * abs(a.x * l.a + a.y * l.b + l.c)) / (long double)(l.a * l.a + l.b * l.b);
}


pair <long double,Pnt> get_ (Pnt a,Pnt b,Pnt c) {
    Vec a_b(a,b);
    Vec b_a(b,a);
    long double d = dist2(a,c);
    long double r = dist2(c,Line(a,b));
    long double z = sqrt(d - r);
    if (abs(z) <= eps) {
        return m_p(sqrt(r),a);
    }
    a_b = a_b * (z / a_b.ln());
    b_a = b_a * (z / a_b.ln());
    if (abs(dist2(Pnt(a.x + a_b.x,a.y + a_b.y),c) - r) <= abs(dist2(Pnt(a.x + b_a.x,a.y + b_a.y),c) - r)) {
        return m_p(sqrt(r),Pnt(a.x + a_b.x,a.y + a_b.y));
    }
    return m_p(sqrt(r),Pnt(a.x + b_a.x,a.y + b_a.y));
}

void solve () {
    int n;
    cin >> n;
    vector <Pnt> a(n);
    for (int i = 0;i < n;i++) {
        cin >> a[i].x >> a[i].y;
    }
    sort (a.begin(),a.end());
    long double ans = INF;
    do {
        long double lc = sqrt(dist2(a[0],a[1]));
        Pnt p = a[0];
        for (int i = 2;i < n;i++) {
            pair <long double,Pnt> t = get_(p,a[i - 1],a[i]);
            p = t.second;
            lc += t.first + sqrt(dist2(p,a[i - 1]));

        }
        ans = min(ans,lc);
    } while (next_permutation(a.begin(),a.end()));
    cout << fixed << setprecision(6) << ans;

}
signed main() {
    solve();

    return 0;
}